###données Pound/USD ouverture
pusd=read.csv("Pound_USD.csv")
data.pound.usd=pusd$Open
dpu=c()
for (i in 1:(length(data.pound.usd)-1)){
  dpu[i]=log(data.pound.usd[i+1]/data.pound.usd[i])
}

###données Pound/USD ouverture
yusd=read.csv("Yen_USD.csv")
data.yen.usd=yusd$Open
dyu=c()
for (i in 1:(length(data.yen.usd)-1)){
  dyu[i]=log(data.yen.usd[i+1]/data.yen.usd[i])
}

plot(dpu,dyu,main="Log returns of daily exchange rates",xlab="Log return of Pound/USD",ylab="Log return of Yen/USD")

#### change!ent de forme
R=sqrt(dpu^2+dyu^2)
theta=-atan(dyu/dpu)

#### extreme value index

hill=function(data,k){
  n=length(data)
  temps=sort(data)
  seuil=temps[n-k]
  I=data>seuil
  extremes=data[I]
  res=mean(log(extremes/seuil))
  return(res)
}

evis=c()
for (i in 1:(length(R)-1)){
  evis[i]=hill(R,i)
}

###proche de juan juan, john and laurens
plot(evis[10:300],type="l")
val.seuil=mean(evis[60:200])
abline(mean(evis[60:200]))
abline(b=1/80)

### donnée pour le test
I=evis>val.seuil
sort(R,decreasing = TRUE)[I]
plot(sort(R,decreasing = TRUE)[1:100])

treshold=sort(R,decreasing = TRUE)[170]
data.r=R[R>treshold]
data.t=theta[R>treshold]

mrv.exh=list(Z=data.r,T=data.t)


#### mise en place du test

N=500
B=1000
lvl=0.05
Ncpus <- parallel::detectCores() - 1
cl <- parallel::makeCluster(Ncpus)
doParallel::registerDoParallel(cl)

result=foreach (i = 1:N, .combine = 'c') %dopar% {
  treshold=sort(R,decreasing = TRUE)[i+1]
  data.r=log(R[R>treshold]/treshold)
  k=length(data.r)
  data.t=theta[R>treshold]
  data=list(Z=data.r,T=data.t)
  g_step=round(max(data$Z))+1
  argu=seq(1,g_step,by=g_step/20)
  angle=seq(0,2*pi,by=(2*pi)/length(seq(1,g_step,by=g_step/20)))
  angle=angle[-length(angle)]
  grille=expand.grid(argu,angle)
  temp=test.boots(data$T,data$Z,B,lvl)
  result<-temp$p.val
}
parallel::stopCluster(cl)

par(mfrow=c(2,1))
plot(evis[1:300],type="l",ylab="Extreme value index",xlab="k",main="daily exchange rates")
abline(h=0.256,col="red")
plot(result[1:300],type="l",ylab="p-value",xlab="k")
abline(h=0.05,col="red")
#abline(h=0.1,col="green")
