### data genreting process

get_data=function(n,k,eps){
  U=runif(n)
  V=runif(n)
  theta=rep(1,n)
  Y=U^{-gamma_0}
  index_tete=(V>eps)
  temps=1:n
  for ( i in temps[index_tete]){
    W=rbinom(1,1,0.5)
    theta[i]=pi*V[i]*W+(1-W)*(pi+pi*V[i])
  }
  index_bouche=as.logical(rep(T,n)-index_tete)
  for ( i in temps[index_bouche]){
    if ((round(-log(U[i])/log(2)+1))%%2==1) {theta[i]=pi*V[i]}
    else{theta[i]=pi+pi*V[i]}
  }
  seuil=sort(Y)[n-k]
  I=(Y>seuil)
  Z=log(Y[I]/seuil)
  T=theta[I]
  return(list(T=T,Z=Z))
}



#### camputation of max ( delta_1, delta_2)

delta1=function(data){
  L=data/mean(data) 
  grille=seq(1,round(max(L))+1,by=0.1)
  delta_temp=grille
  for (i in 1:length(grille)) {
    delta_temp[i]=mean(L>grille[i])-exp(-grille[i])
  }
  delta=max(abs(delta_temp),exp(-max(L)))
  return(delta)
}

delta2=function(Z,T){
  argu=seq(1,round(max(Z))+1,by=0.1)
  angle=seq(0,2*pi,by=(2*pi)/length(seq(1,round(max(Z))+1,by=0.1)))
  angle=angle[-length(angle)]
  grille=expand.grid(argu,angle)
  F=c()
  F1=c()
  F2=c()
  for (i in 1:length(grille[,1])){
    F[i]=mean((Z>grille[i,1])&(T<=grille[i,2]))
    F1[i]=mean(Z>grille[i,1])
    F2[i]=mean(T<=grille[i,2])
  }
  delta=max(abs(F-F1*F2))
  return(delta)
}


#### Bootstrap procedure

#### Evaluation du Z_{k,P}
###valeur de la fonction dans le sup en t pour un t fix?
first.term=function(t,sam.d,sam.b,H){
  k=length(sam.d)
  T1=-t*exp(-t)/H*sqrt(k)*(mean(sam.b)-H)
  T2=sqrt(k)*(mean(sam.b>(t/H))-mean(sam.d>(t/H)))
  return(T1+T2)
}
###valeur de la fonction dans le sup en t et theta avec t et theta fix?s
second.term=function(t,theta,sam.d,sam.b,H){
  t1=sqrt(k)*(mean((sam.b[,2]>t)&(sam.b[,1]<=theta))-mean((sam.d[,2]>t)&(sam.d[,1]<=theta)))
  t2=sqrt(k)*(mean(sam.b[,2]>(t))-mean(sam.d[,2]>(t)))*mean(sam.d[,1]<=theta)
  t3=mean(sam.d[,2]>t)*sqrt(k)*(mean(sam.b[,1]<=theta)-mean(sam.d[,1]<=theta))
  return(t1-t2-t3)
}

##fonction qui calcul la stat Z_{k,P} pour une it?ration bootstrap
Zkp=function(data.angle,data.arg){
  Hill=mean(data.arg)
  sample.d=cbind(data.angle,data.arg)
  index=sample(1:k,replace=TRUE)
  boot.sample=cbind(data.angle[index],data.arg[index])
  stat.t1=c()
  for (i in 1:length(argu)){
    stat.t1[i]=first.term(grille[i,1],data.arg,data.arg[index],Hill)
  }
  stat.t2=c()
  for (i in 1:length(grille[,1])) {
    stat.t2[i]=second.term(grille[i,1],grille[i,2],sample.d,boot.sample,Hill)
  }
  return(max(max(abs(stat.t1)),max(abs(stat.t2))))
}



test.boots=function(data.angle,data.arg,B,lvl){
  d1=delta1(data.arg)
  d2=delta2(data.arg,data.angle)
  Tdelta=sqrt(k)*max(d1,d2)
  boots=replicate(B,Zkp(data.angle,data.arg))
  q=quantile(boots,1-lvl)
  p.val=mean(Tdelta<boots)
  return(list(Tdelta=Tdelta,q=q,p.val=p.val,d1=d1,d2=d2))
}

###### tests

lvlvect=c(0.1,0.05,0.01)
resvect=rep(0,3)

for (i in 1:3){
gamma_0= 1
alpha.p=3/(gamma_0*4)
n=3000
k=150
eps=0#0.7
lvl=lvlvect[i]

B=10000
N=10000
Ncpus <- parallel::detectCores() - 1
cl <- parallel::makeCluster(Ncpus)
doParallel::registerDoParallel(cl)

result=foreach (i = 1:N, .combine = 'c') %dopar% {
  data=get_data(n,k,eps)
  g_step=round(max(data$Z))+1
  argu=seq(1,g_step,by=g_step/20)
  angle=seq(0,2*pi,by=(2*pi)/length(seq(1,g_step,by=g_step/20)))
  angle=angle[-length(angle)]
  grille=expand.grid(argu,angle)
  temp=test.boots(data$T,data$Z,B,lvl)
  result<-c(temp$Tdelta,temp$q,temp$p.val,temp$d1,temp$d2)
}
parallel::stopCluster(cl)

indices=seq(1,5*N,by=5)

resvect[i]=mean(result[indices]<result[indices+1])
}

